<?php 
/**
 * Model for Logins
 *
 * @author Mills ABeiku Godfred
 */
class Login
{
	
	public $conn;
	
	function __construct()
	{
		$this->conn = Database::connect();
	}

    public function update_login(array $key_col_vals, array $values) {
        $sql = "UPDATE login SET ";
        $fields = array_keys($values);
        $vals = array_values($values);
        $key_cols = array_keys($key_col_vals);
        $key_vals = array_values($key_col_vals);
        foreach ($fields as $i=>$f) {
            $fields[$i] .= " = ? ";
        }

        $sql .= implode(",", $fields);
        $sql .= " WHERE " ;
        
        foreach ($key_cols as $i=>$f) {
            $key_cols[$i] .= " = ? ";
        }
        
        $sql .= implode(" AND ", $key_cols);

        $statement = $this->conn->prepare($sql);
        foreach ($vals as $i=>$v) {
            $statement->bindValue($i+1, $v);
        }
        
        foreach ($key_vals as $i=>$v) {
           if($i==0){
               $statement->bindValue((count($fields)+$i+1), $v);
            }else{
               $statement->bindValue((count($fields)+$i), $v);
            }
        }
        
       return  $statement->execute();

	}


	public function set_log(array $data){
		$sql = "INSERT INTO login_history ";
		$fields = array_keys($data);
		$vals = array_values($data);

		$sql .= "(".implode(",", $fields).")";
		$arr = array();
		foreach ($fields as $f) {
			$arr[] = "?";
		}
		$sql .= " VALUES(".implode(",", $arr).")";

		$statement = $this->conn->prepare($sql);

		foreach ($vals as $i => $v) {
			$statement->bindValue($i + 1, $v);
		}

		return $statement->execute();

	}

	public function add_login(array $data){
		$sql = "INSERT INTO login ";
		$fields = array_keys($data);
		$vals = array_values($data);

		$sql .= "(".implode(",", $fields).")";
		$arr = array();
		foreach ($fields as $f) {
			$arr[] = "?";
		}
		$sql .= " VALUES(".implode(",", $arr).")";

		$statement = $this->conn->prepare($sql);

		foreach ($vals as $i => $v) {
			$statement->bindValue($i + 1, $v);
		}

		return $statement->execute();

	}

	public function set_attempt_log(array $data){
		$sql = "INSERT INTO login_attempts_history ";
		$fields = array_keys($data);
		$vals = array_values($data);

		$sql .= "(".implode(",", $fields).")";
		$arr = array();
		foreach ($fields as $f) {
			$arr[] = "?";
		}
		$sql .= " VALUES(".implode(",", $arr).")";

		$statement = $this->conn->prepare($sql);

		foreach ($vals as $i => $v) {
			$statement->bindValue($i + 1, $v);
		}

		return $statement->execute();

	}    
	
	public function auth($email,$phone,$key){
		$sql = "SELECT * FROM student WHERE email=:email
         AND phone=:phone  AND EXISTS (SELECT * FROM exam WHERE exam_key=:key AND status='Active')";
		$statement = $this->conn->prepare($sql);
		$statement->bindParam(":email",$email);
		$statement->bindParam(":phone",$phone);
        $statement->bindParam(":key",$key);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

    public function check_username($username){
		$sql = "SELECT a.*,b.* FROM login a JOIN employee b 
        ON a.phone=b.employee_phone || a.email=b.employee_email 
        JOIN role c ON b.employee_role_id=c.role_id
         WHERE a.email=:username || a.phone=:username";
		$statement = $this->conn->prepare($sql);
		$statement->bindParam(":username",$username);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

	public function remove_employee_login($email,$phone){
		$sql = "DELETE FROM login WHERE email=:email || phone=:phone";
		$statement = $this->conn->prepare($sql);
		$statement->bindParam(":email",$email);
        $statement->bindParam(":phone",$phone);
		$statement->execute();
		if ($statement->rowCount() > 0) {
            $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

}